import { RabbitSubscribe } from '@golevelup/nestjs-rabbitmq';
import { Inject } from '@nestjs/common';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import loggerOptions from '../logger.options';
import { level } from '../level.enum';
import { GATEWAY_API_HEALTH_CRIT_MESSAGE_HANDLER } from '@src/app.constants';

export class GatewayApiMessageHandler {
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {}

  @RabbitSubscribe({
    name: GATEWAY_API_HEALTH_CRIT_MESSAGE_HANDLER,
  })
  public async gatewayApiHealthCriticalHandler(message: string) {
    this.logger.configure(
      loggerOptions('gateway-api', level.crit, 'crit', 'health'),
    );
    this.logger.crit(JSON.parse(message));
  }
}
